﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections.Generic;

namespace NetJsWire.Direct.helper
{
    /// <summary>
    ///   Simple cache for Ext.Direct providers
    /// </summary>
    public class DirectProviderCache : Dictionary<string, DirectProvider>
    {

        static readonly DirectProviderCache instance = new DirectProviderCache();
        private Dictionary<string, DirectProviderCache> providers;

        DirectProviderCache()
        {
            providers = new Dictionary<string, DirectProviderCache>();
        }

        /// <summary>
        ///   Gets the singleton instance of this object.
        /// </summary>
        /// <returns>The DirectProviderCache instance.</returns>
        public static DirectProviderCache GetInstance()
        {
            return instance;
        }

    }
}
