﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.Data;
using Newtonsoft.Json;

namespace NetJsWire.Direct.helper
{
    /// <summary>
    ///   Just a small wrapper class for the correct response for a read Action.
    /// </summary>
    public class LoadResponse
    {
        [JsonProperty(PropertyName = "success")]
        public bool Success = true;

        public LoadResponse() { }
        public LoadResponse(DataTable dataTable)
        {
            var arr = new DataRow[ dataTable.Rows.Count];
            dataTable.Rows.CopyTo(arr, 0);

            Rows = arr;
            Results = dataTable.Rows.Count;
        }

        /// <summary>
        ///   the property which contains the total dataset size (optional)
        /// </summary>
        [JsonProperty(PropertyName="results")]
        public int Results
        {
            get;
            set;
        }


        [JsonProperty(PropertyName = "data")]
        public Object Rows
        {
            get;
            set;
        }
    }
}
