﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using NetJsWire.Lite.Widgets.UI.Data;
using Newtonsoft.Json;
using JsonReader = Newtonsoft.Json.JsonReader;
using JsonWriter = Newtonsoft.Json.JsonWriter;

namespace NetJsWire.Lite.Converters
{
    public class DataWriterJsonConverter : JsonConverter
    {
        public override bool CanConvert( Type objectType )
        {
            return typeof( DataWriter ).IsAssignableFrom( objectType );
        }

        public override object ReadJson( JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer )
        {
            throw new NotImplementedException();
        }

        public override void WriteJson( JsonWriter writer, object value, JsonSerializer serializer )
        {
            var cm = value as DataWriter;
            if ( cm != null )
            {
                if ( cm is Widgets.UI.Data.JsonWriter )
                    writer.WriteStartConstructor( "Ext.data.JsonWriter" );
                else if ( cm is XmlWriter )
                    writer.WriteStartConstructor( "Ext.data.XmlWriter" );
                else
                    writer.WriteStartConstructor( "Ext.data.DataWriter" );

                writer.WriteRaw( JsonConvert.SerializeObject( value, Formatting.Indented, new JsonConverter[] { new ListenerCollectionJsonConverter() } ) );

                writer.WriteEndConstructor();
            }
        }
    }
}
