﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.ComponentModel;
using System.ComponentModel.Design.Serialization;
using System.Globalization;
using NetJsWire.Lite.Widgets.UI.Grid;

namespace NetJsWire.Lite.Converters
{
    internal class GridViewConverter : ExpandableObjectConverter
    {
        public override bool CanConvertTo( ITypeDescriptorContext context, Type destinationType )
        {
            return ( ( destinationType == typeof (InstanceDescriptor) ) || base.CanConvertTo( context, destinationType ) );
        }

        public override object ConvertTo( ITypeDescriptorContext context, CultureInfo culture, object value,
                                          Type destinationType )
        {
            if ( destinationType == null )
            {
                throw new ArgumentNullException( "destinationType" );
            }
            var gv = value as GridView;
            if ( ( destinationType == typeof (InstanceDescriptor) ) && ( gv != null ) )
            {
                var constructor = gv.GetType().GetConstructor( new Type[0] );
                if ( constructor != null )
                {
                    return new InstanceDescriptor( constructor, new object[0], false );
                }
            }
            return base.ConvertTo( context, culture, value, destinationType );
        }
    }
}