﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.Windows.Forms;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Converters
{
    public class PaddingJsonConverter : JsonConverter
    {
        public override bool CanConvert( Type objectType )
        {
            return typeof( Padding ).IsAssignableFrom( objectType );
        }

        public override object ReadJson( JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer )
        {
            throw new NotImplementedException();
        }

        public override void WriteJson( JsonWriter writer, object value, JsonSerializer serializer )
        {
            var p = ( Padding ) value;

            if ( p.All > 0 )
                writer.WriteValue( p.All );

            if ( p.All == -1 )
            {
                var strPadding = p.Top + "px " + p.Right + "px " + p.Bottom + "px " + p.Left + "px";
                writer.WriteValue( strPadding );
            }
        }
    }
}
