﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;

namespace NetJsWire.Lite.Converters
{
    public class XtypeTypeConverter : StringConverter
    {
        public override bool GetStandardValuesSupported( ITypeDescriptorContext context )
        {
            return true;
        }

        public override StandardValuesCollection GetStandardValues( ITypeDescriptorContext context )
        {
            return new StandardValuesCollection( new[]
                                                    {
                                                        "box", "button", "buttongroup", "colorpalette", "component",
                                                        "container", "cycle", "dataview", "datepicker", "editor",
                                                        "editorgrid", "flash", "grid", "listview", "multislider",
                                                        "panel", "progress", "propertygrid", "slider", "spacer",
                                                        "splitbutton", "tabpanel", "treepanel", "viewport", "paging",
                                                        "toolbar", "tbfill", "tbitem", "tbseparator", "tbspacer",
                                                        "tbtext", "menu", "colormenu", "datemenu", "menubaseitem",
                                                        "menucheckitem", "menuitem", "menuseparator", "menutextitem",
                                                        "form", "checkbox", "checkboxgroup", "combo", "compositefield",
                                                        "datefield", "displayfield", "field", "fieldset", "hidden",
                                                        "htmleditor", "label", "numberfield", "radio", "radiogroup",
                                                        "textarea", "textfield", "timefield", "trigger", "chart",
                                                        "barchart", "cartesianchart", "columnchart", "linechart",
                                                        "piechart", "arraystore", "directstore", "groupingstore",
                                                        "jsonstore", "store", "xmlstore"
                                                    } );
        }

        public override bool GetStandardValuesExclusive( ITypeDescriptorContext context )
        {
            return false;
        }
    }
}