﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace NetJsWire.Design
{
    interface IUISelectionService
    {
        bool SelectionInProgress
        {
            get;
        }
        bool DragDropInProgress
        {
            get;
        }
        bool ResizeInProgress
        {
            get;
        }

        void MouseDragBegin( Control container, int x, int y );
        void MouseDragMove( int x, int y );
        void MouseDragEnd( bool cancel );

        void DragBegin();
        void DragOver( Control container, int x, int y );
        void DragDrop( bool cancel, Control container, int x, int y );

        void PaintAdornments( Control container, Graphics gfx );
        bool SetCursor( int x, int y );

        bool AdornmentsHitTest( Control control, int x, int y );
    }
}
