#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections;
using System.ComponentModel;
using NetJsWire.Lite.Widgets.UI.Util;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Data
{
    /// <summary>
    ///   /**
    ///   @cfg {Boolean} leaf true if this node is a leaf and does not have children
    ///   @cfg {String} id The id for this node. If one is not specified, one is generated.
    /// </summary>
    [ToolboxItem( false )]
    public class Node : BaseObservable
    {
        /// <summary>
        ///   The node id. @type String
        /// </summary>
        [JsonProperty( "id" )]
        public object Id { get; set; }

        /// <summary>
        ///   All child nodes of this node. @type Array
        /// </summary>
        [JsonProperty( "childNodes" )]
        public virtual IList ChildNodes { get; set; }
    }
}
