﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Data
{
    [JsonObject( MemberSerialization = MemberSerialization.OptIn )]
    public class XmlStore : Store
    {
        ///<summary>
        ///  Initializes a new instance of XmlStore.
        ///</summary>
        public XmlStore()
            : this( null )
        {
        }

        ///<summary>
        ///  Initializes a new instance of XmlStore and adds it to the Container.
        ///</summary>
        ///<param name = "container"></param>
        public XmlStore( IContainer container )
            : base( container )
        {
            base.Xtype = "xmlstore";
        }

        [Description( "The DomQuery path relative from the record element to the element that contains a record identifier value." )]
        [JsonProperty( "idPath", NullValueHandling = NullValueHandling.Ignore, DefaultValueHandling = DefaultValueHandling.Ignore )]
        [DefaultValue( ( string ) null )]
        public string IdPath { get; set; }

        [Description( "The DomQuery path to the repeated element which contains record information." )]
        [JsonProperty( "record", NullValueHandling = NullValueHandling.Ignore, DefaultValueHandling = DefaultValueHandling.Ignore )]
        [DefaultValue( ( string ) null )]
        public string Record { get; set; }
    }
}
