#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Dd
{
    /// <summary>
    ///   /**
    ///   A DragDrop implementation where the linked element follows the
    ///   mouse cursor during a drag.
    /// </summary>
    public class DD : DragDrop
    {
        /// <summary>
        ///   When set to true, the utility automatically tries to scroll the browser
        ///   window when a drag and drop element is dragged near the viewport boundary.
        ///   Defaults to true.
        /// </summary>
        [JsonProperty( "scroll" )]
        public bool Scroll { get; set; }
    }
}
