#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Dd
{
    /// <summary>
    ///   /**
    ///   A custom drag proxy implementation specific to {@link Ext.Panel}s. This class is primarily used internally
    ///   for the Panel's drag drop implementation, and should never need to be created directly.
    /// </summary>
    public class PanelProxy
    {
        /// <summary>
        ///   True to insert a placeholder proxy element while dragging the panel,false to drag with no proxy (defaults to true).
        /// </summary>
        [JsonProperty( "insertProxy" )]
        public bool InsertProxy { get; set; }
    }
}
