#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Dd
{
    /// <summary>
    ///   /**
    ///   A specialized drag proxy that supports a drop status icon, {@link Ext.Layer} styles and auto-repair.  This is the
    ///   default drag proxy used by all Ext.dd components.
    /// </summary>
    public class StatusProxy
    {
        /// <summary>
        ///   The CSS class to apply to the status element when drop is allowed (defaults to "x-dd-drop-ok").
        /// </summary>
        [JsonProperty( "dropAllowed" )]
        public string DropAllowed { get; set; }

        /// <summary>
        ///   The CSS class to apply to the status element when drop is not allowed (defaults to "x-dd-drop-nodrop").
        /// </summary>
        [JsonProperty( "dropNotAllowed" )]
        public string DropNotAllowed { get; set; }
    }
}
