﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Form
{
    public class DisplayField : FieldLW
    {
        protected DisplayField()
            : this( null )
        {
        }

        protected DisplayField( IContainer container )
            : base( container )
        {
            base.Xtype = "field";
        }

        /// <summary>
        ///   The default CSS class for the field (defaults to <tt>"x-form-display-field"</tt>)
        /// </summary>
        [JsonProperty( "fieldClass" )]
        [Description( "The default CSS class for the field (defaults to <tt>'x-form-display-field'</tt>)" )]
        public override string FieldClass { get; set; }

        /// <summary>
        ///   <tt>false</tt> to skip HTML-encoding the text when rendering it (defaults to<tt>false</tt>). This might be useful if you want to include tags in the field's innerHTML rather than
        ///   rendering them as string literals per the default logic.
        /// </summary>
        [JsonProperty( "htmlEncode" )]
        public bool HtmlEncode { get; set; }

    }
}
