﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.Lite.Converters;
using NetJsWire.Lite.Designers;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Form
{
    [Designer( typeof( HiddenDesigner ) )]
    public class Hidden : FieldLW
    {
        public Hidden()
            : this( null )
        {
        }

        public Hidden( IContainer container )
            : base( container )
        {
            base.Xtype = "hidden";
        }

        [JsonConverter( typeof( NotQuotedJsonStringConverter ) )]
        [JsonProperty( "value", DefaultValueHandling = DefaultValueHandling.Ignore, NullValueHandling = NullValueHandling.Ignore )]
        [DefaultValue( ( string ) null )]
        [TypeConverter( typeof( StringConverter ) )]
        public override object Value
        {
            get
            {
                return base.Value;
            }
            set
            {
                base.Value = value;
            }
        }
    }
}
