#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Grid
{
    /// <summary>
    ///   /**
    ///   <p>A Column definition class which renders boolean data fields.  See the {@link Ext.grid.Column#xtype xtype}
    ///     config option of {@link Ext.grid.Column} for more details.</p>
    ///   */
    ///   Ext.grid.BooleanColumn = Ext.extend(Ext.grid.Column, {
    /// </summary>
    [Serializable]
    public class BooleanColumn : Column
    {
        internal BooleanColumn()
            : this( null )
        {
        }

        public BooleanColumn( ColumnModel model )
            : base( model )
        {
            Xtype = "booleancolumn";
        }

        /// <summary>
        ///   The string returned by the renderer when the column value is not false (defaults to <tt>'true'</tt>).
        /// </summary>
        [JsonProperty( "trueText" )]
        public string TrueText { get; set; }

        /// <summary>
        ///   The string returned by the renderer when the column value is false (but not undefined) (defaults to
        ///   <tt>'false'</tt>).
        /// </summary>
        [JsonProperty( "falseText" )]
        public string FalseText { get; set; }

        /// <summary>
        ///   The string returned by the renderer when the column value is undefined (defaults to <tt>'&amp;#160;'</tt>).
        /// </summary>
        [JsonProperty( "undefinedText" )]
        public string UndefinedText { get; set; }
    }
}
