﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.Collections.Generic;

namespace NetJsWire.Lite.Widgets.UI.Grid
{
    [Serializable]
    public class ColumnCollection : List<Column>
    {
        private readonly ColumnModel _collectionOwner;
        public ColumnCollection( ColumnModel collectionOwner )
        {
            _collectionOwner = collectionOwner;
        }

        public void AddRange( params Column[] columns )
        {
            if ( columns == null )
                return;
            foreach ( var column in columns )
            {
                Add( column );
            }
        }

        public new void Add( Column column )
        {
            column.Owner = _collectionOwner;
            base.Add( column );
        }
    }
}