﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.Lite.Widgets.UI.Util;

namespace NetJsWire.Lite.Widgets.UI.Grid.Plugins
{
    [ProvideProperty( "SummaryType", typeof( Column ) )]
    [ProvideProperty( "SummaryRenderer", typeof( Column ) )]
    public class GroupSummary : BaseObservable, IExtenderProvider
    {
        ///<summary>
        ///  Initializes a new instance of GroupSummary.
        ///</summary>
        public GroupSummary()
            : this( null )
        {
        }

        ///<summary>
        ///  Initializes a new instance of GroupSummary and adds it to the Container.
        ///</summary>
        ///<param name = "container"></param>
        public GroupSummary( IContainer container )
        {
            if ( container != null )
                container.Add( this );
        }

        #region Provided propertys

        public string GetSummaryType( Column col )
        {
            return "Test";
        }

        public void SetSummaryType( Column col, string st )
        {
        }

        public string GetSummaryRenderer( Column col )
        {
            return "TestRenderer";
        }

        public void SetSummaryRenderer( Column col, string st )
        {
        }

        #endregion

        #region Miembros de IExtenderProvider

        public bool CanExtend( object extendee )
        {
            return extendee is Column;
        }

        #endregion
    }
}
