﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.Lite.Widgets.UI.Util;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Grid
{
    [JsonObject( MemberSerialization = MemberSerialization.OptIn )]
    public abstract class SelectionModel : BaseObservable
    {
        ///<summary>
        ///  Initializes a new instance of SelectionModel.
        ///</summary>
        public SelectionModel()
            : this( null )
        {
        }

        ///<summary>
        ///  Initializes a new instance of SelectionModel and adds it to the Container.
        ///</summary>
        ///<param name = "container"></param>
        public SelectionModel( IContainer container )
        {
            if ( container != null )
                container.Add( this );
        }
    }
}
