﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using System.Windows.Forms;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Layout.Config
{
    public class BoxLayoutConfig : LayoutConfig
    {
        [JsonProperty( "defaultMargins" )]
        [DefaultValue( typeof( Padding ), "0, 0, 0, 0" )]
        public Padding DefaultMargins { get; set; }

        [JsonProperty( "padding" )]
        [DefaultValue( typeof( Padding ), "0, 0, 0, 0" )]
        public Padding Padding { get; set; }

        public override bool ShouldSerialize()
        {
            return base.ShouldSerialize() || DefaultMargins.Horizontal != 0 || DefaultMargins.Vertical != 0 || Padding.Horizontal != 0 || Padding.Vertical != 0;
        }
    }
}
