﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion
namespace NetJsWire.Lite.Widgets.UI.Layout
{
    /// <summary>
    ///   The type of layout used for this container.
    /// </summary>
    public enum LayoutType
    {
        /// <summary>
        ///   Automatic layout (default)
        /// </summary>
        Auto = 0,
        /// <summary>
        ///   Absolute layout
        /// </summary>
        Absolute,
        /// <summary>
        ///   Anchor layout
        /// </summary>
        Anchor,
        /// <summary>
        ///   Fit layout.
        /// </summary>
        Fit,
        /// <summary>
        ///   Border layout
        /// </summary>
        Border,
        /// <summary>
        ///   Accordion layout
        /// </summary>
        Accordion,
        /// <summary>
        ///   Card layout
        /// </summary>
        Card,
        /// <summary>
        ///   Column layout
        /// </summary>
        Column,
        /// <summary>
        ///   Form layout
        /// </summary>
        Form,
        /// <summary>
        ///   Table layout
        /// </summary>
        Table,
        /// <summary>
        ///   Hbox layout
        /// </summary>
        Hbox,
        /// <summary>
        ///   Vbox layout
        /// </summary>
        Vbox,
        /// <summary>
        ///   Toolbar layout
        /// </summary>
        Toolbar
    }
}