#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Toolbar
{
    /// <summary>
    ///   /**
    ///   The base class that other non-interacting Toolbar Item classes should extend in order to
    ///   get some basic common toolbar item functionality.
    /// </summary>
    public class Item : BoxComponent
    {
        /// <summary>
        ///   Creates a new Item
        ///   @xtype tbitem
        /// </summary>
        /// <returns></returns>
        public Item()
        {
            base.Xtype = "menuitem";
        }

        /// <summary>
        ///   Text to be used for the menu if the item is overflowed.
        /// </summary>
        [JsonProperty( "overflowText" )]
        public string OverflowText { get; set; }
    }
}
