#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Tree
{
    /// <summary>
    ///   /**
    ///   @cfg {TreeLoader} loader A TreeLoader to be used by this node (defaults to the loader defined on the tree)
    /// </summary>
    public class AsyncTreeNode : TreeNode
    {
        /// <summary>
        ///   The loader used by this node (defaults to using the tree's defined loader)
        /// </summary>
        [JsonProperty( "loader" )]
        public TreeLoader Loader { get; set; }
    }
}
