#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.Lite.Widgets.UI.Dd;
using Newtonsoft.Json;

namespace NetJsWire.Lite.Widgets.UI.Tree
{
    /// <summary>
    ///   /**
    /// </summary>
    public class TreeDragZone : DragZone
    {
        /// <summary>
        ///   The TreePanel for this drag zone
        /// </summary>
        [JsonProperty( "tree" )]
        public TreePanel Tree { get; set; }

        /// <summary>
        ///   A named drag drop group to which this object belongs.  If a group is specified, then this object will only
        ///   interact with other drag drop objects in the same group (defaults to 'TreeDD').
        /// </summary>
        [JsonProperty( "ddGroup" )]
        public override string DdGroup { get; set; }
    }
}
