#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;

namespace NetJsWire.JsonRpcHandler.Attributes
{
    /// <summary>
    /// </summary>
    /// <exclude />
    [ AttributeUsage( AttributeTargets.Class, Inherited = false, AllowMultiple = false ) ]
    public sealed class RendererAttribute : Attribute
    {
        private readonly Type _rendererType;

        public RendererAttribute( Type rendererType )
        {
            _rendererType = rendererType;
        }

        public Type RendererType
        {
            get { return _rendererType; }
        }
    }
}