#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.IO;
using System.Text;
using System.Web;
using System.Web.SessionState;
using NetJsWire.JsonRpcHandler.Util;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace NetJsWire.JsonRpcHandler.Handlers
{
    internal class EmbeddedHandler : IHttpHandler, IRequiresSessionState
    {
        private readonly string _mods;

        internal EmbeddedHandler( string mods )
        {
            _mods = mods;
        }

        #region IHttpHandler Members

        public void ProcessRequest( HttpContext context )
        {
            if ( _mods != "index" && _mods != "unload" )
            {
                context.Response.ContentType = "text/html";
                //WebApplication currentApp;
                //int appNum = -1;
                var sb = new StringBuilder();
                sb.AppendLine( "<html><head><title>Status Page</title></head><body>" );
                var ts = TimeSpan.FromMilliseconds( Environment.TickCount );
                sb.AppendFormat( "Server up time: {0} days, {1} hours, {2} minutes, {3} seconds.", ts.Days, ts.Hours,
                                 ts.Minutes, ts.Seconds );
                //PerformanceCounter perfFreeMem = new PerformanceCounter("Memory", "Available MBytes");
                //PerformanceCounter pc = new PerformanceCounter("System", "System Up Time");
                //pc.NextValue();
                //TimeSpan ts2 = TimeSpan.FromSeconds(pc.NextValue());
                //sb.AppendFormat("<br />Available memory: {0}<br/>Appication uptime: {1} days, {2}hours, {3} minutes, {4} seconds.", perfFreeMem.NextValue(), ts2.Days, ts2.Hours, ts2.Minutes, ts2.Seconds);
                switch ( _mods )
                {
                    case "status":
                        /*
                        WebApplication.SetInstanceContext(context);
                        string statusFromUser = WebApplication.Instance.OnStatusRequest();
                        if(!string.IsNullOrEmpty(statusFromUser))
                        {
                            sb.Append(statusFromUser);
                            break;
                        }
                        if (WebApps.HasObjects)
                        {
                            if (context.Request.QueryString["appNum"] != null)
                            {
                                appNum = Convert.ToInt32(context.Request.QueryString["appNum"]);
                                currentApp = WebApps.GetObjectAt(appNum) as WebApplication;
                            }
                            else
                            {
                                currentApp = WebApplication.Instance;
                            }

                            sb.AppendLine("<p>Current app.</p>");
                            sb.AppendLine("<select id='selAppNum' name='selAppNum' style='width: 250px' onchange=\"javascript:window.location='/webapp/Status.ashx?appNum=' + selAppNum.value\">");
                            
                            if (appNum < 0)
                                appNum = 0;

                            for (int i = 0; i < WebApps.ObjectCount; i++)
                            {
                                if (i == appNum)
                                    sb.AppendFormat("<option value='{0}' selected='selected'>Application {0}</option>", i);
                                else
                                    sb.AppendFormat("<option value='{0}'>Application {0}</option>", i);
                            }
                            sb.AppendLine("</select>");

                            sb.AppendFormat("<p>App IP: {0} - App host: {1}</p>", currentApp.ClientIP, currentApp.ClientHostName);
                            sb.AppendFormat("<p>Client User Agent: {0}</p>", currentApp.ClientUserAgent);

                            //context.Profile.Properties
                            //sb.AppendFormat("<p>Objects in your Session: {0}.</p>", context.Session != null ? context.Session.Count : 0, Environment.NewLine);
                            sb.AppendFormat("<p>Loaded apps (clients connected): {0}.</p>", WebApps.ObjectCount, Environment.NewLine);
                            //sb.AppendFormat("<p>ID de la sesion: {0}.</p>", context.Session.SessionID, Environment.NewLine);
                            //if (context.Session["WebApplication"] != null && context.Session["WebApplication"].ToString() == context.Session.SessionID)
                            if(currentApp != null)
                            {
                                sb.AppendFormat("<p>Amount of objects in current Application: {0}.</p>", currentApp.Objects.Count, Environment.NewLine);
                                sb.Append("Detail: <br />");
                                sb.AppendLine("<table border='1' width='99%'>");
                                sb.AppendLine("<tr style='background-color:yellow;'><td title='The name in server side.'>Name</td><td title='The name in client side.'>ID</td><td title='The type of the in server side.'>Type</td></tr>");
                                foreach (object o in currentApp.Objects.Values)
                                {
                                    sb.AppendLine("<tr>");
                                    string name = "";
                                    string type = o.GetType().Name;
                                    string objId = string.Empty;
                                    if (o is IWidget)
                                    {
                                        if (o is System.Windows.Forms.Control)
                                            name = (o as System.Windows.Forms.Control).Name;
                                        else if (o is System.Windows.Forms.ToolStripItem)
                                            name = (o as System.Windows.Forms.ToolStripItem).Name;
                                        objId = ((o as IWidget).Renderer as NetJsWire.Widgets.Renderers.Core.Widget).InternalID;
                                        sb.AppendFormat("<td><a href='/webapp/ObjDetail.ashx?appNum={0}&objId={1}' target='_blank'>{2}</a></td><td>{3}</td><td>{4}</td>", appNum, objId, name, (o as IWidget).Renderer.ClientID, type);
                                    }
                                    else
                                    {
                                        sb.AppendFormat("<td>{0}</td><td>{1}</td><td>{2}</td>", "N/D", "N/D", type);
                                    }
                                    sb.AppendLine("</tr>");
                                }
                                sb.AppendLine("</table>");
                            }
                        }
                        */
                        break;
                    case "objdetail":
                        /*
                        string strObjId;
                        object obj;
                        if (context.Request.QueryString["appNum"] != null)
                        {
                            appNum = Convert.ToInt32(context.Request.QueryString["appNum"]);
                            currentApp = WebApps.GetObjectAt(appNum) as WebApplication;
                        }
                        else
                        {
                            sb.AppendLine("<p>Incorrect Request</p>");
                            break;
                        }

                        if (context.Request.QueryString["objId"] != null)
                        {
                            strObjId = context.Request.QueryString["objId"];
                            if (currentApp.Objects.ContainsKey(strObjId))
                            {
                                obj = currentApp.Objects[strObjId];
                                if (obj is IWidget)
                                {
                                    string name = "";
                                    if (obj is System.Windows.Forms.Control)
                                        name = (obj as System.Windows.Forms.Control).Name;
                                    else if (obj is System.Windows.Forms.ToolStripItem)
                                        name = (obj as System.Windows.Forms.ToolStripItem).Name;
                                    sb.AppendLine("<p>Object is found.</p>");
                                    sb.AppendFormat("<p>Name: {0}</p><p>Type: {1}</p>", name, obj.GetType().FullName);
                                    sb.AppendLine("<p>Public propertys:</p>");
                                    sb.AppendLine("<table border='1' width='99%'>");
                                    sb.AppendLine("<tr style='background-color:yellow;'><td title='The BlockRefresh name.'>Name</td><td title='BlockRefresh value.'>Value</td></tr>");


                                    PropertyInfo[] propertys = obj.GetType().GetProperties();

                                    foreach (PropertyInfo pi in propertys)
                                    {
                                        sb.AppendFormat("<tr><td>{0}</td><td>{1}</td></tr>", pi.Name, pi.GetValue(obj, null));
                                    }
                                    sb.AppendLine("</table>");

                                }
                                else
                                {
                                    sb.AppendLine("<p>Object is not an instance of IWidget.</p>");
                                    break;
                                }
                            }
                            else
                            {
                                sb.AppendLine("<p>Incorrect Request</p>");
                                break;
                            }
                        }
                        else
                        {
                            sb.AppendLine("<p>Incorrect Request</p>");
                            break;
                        }
                        */
                        break;
                    default:
                        break;
                }
                sb.AppendLine( "</body></html>" );
                context.Response.Write( sb.ToString() );
                context.Response.End();
            }
            else if ( _mods == "unload" )
            {
                WebApplication.Instance.OnUnload();
                // We let users know that we are unloading the application so they can properly cleanup their objects.
                //WebApps.RemoveObject(context.Session.SessionID);
                context.Session.RemoveAll();
                context.Session.Abandon();
            }
            else
            {
                var data = ( new StreamReader( context.Request.InputStream ) ).ReadToEnd();
                var posts = ( JSONRpcPost[] ) JsonConvert.DeserializeObject( data, typeof( JSONRpcPost[] ) );
                var post = posts[ 0 ];
                try
                {
                    if ( context.Session[ "WebApplication" ] != null )
                    {
                        WebApplication.SetInstanceContext( context );
                        WebApplication.Instance.Objects.Clear();
                    }
                    else
                    {
                        WebApplication.Instance = new WebApplication( context.Session.SessionID );
                        context.ApplicationInstance.Error += WebApplication.Instance.ApplicationError;

                        //CHECK: is there a better way to store this for each user?
                        WebApplication.Instance.ClientIP = context.Request.UserHostAddress;
                        WebApplication.Instance.ClientHostName = context.Request.UserHostName;
                        WebApplication.Instance.ClientUserAgent = context.Request.UserAgent;
                        WebApplication.Instance.ClientBrowser = context.Request.Browser;
                        context.Session[ "WebApplication" ] = WebApplication.Instance;
                    }
                    var s = ""; // + Properties.Resources.client + ";";
                    var mainClassName = WebApplication.Instance.SettingsHandler.MainClassName.Split( ',' )[ 0 ];
                    var mainClassAssemblyName = WebApplication.Instance.SettingsHandler.MainClassName.Split( ',' )[ 1 ];
                    Activator.CreateInstance( mainClassAssemblyName, mainClassName );
                    if ( WebApplication.Instance.ClientDocument == null )
                    {
                        throw new Exception( "You must declare a ClientDocument instance." );
                    }

                    //TODO: finnish the setting of browser values in ClientDocument here
                    WebApplication.Instance.ClientDocument.IsIE = ( ( JObject ) post.JSONRpcPostParams.Data )[ "isIE" ].Value<bool>();
                    s += WebApplication.Instance.RenderChanges();
#if (DEBUG)
                    context.Response.Write( JsonConvert.SerializeObject( new JSONRpcResult( post.id, string.Format( "function(){{{0}}}", s ), null ), Formatting.Indented ) );
#else
                    context.Response.Write( Newtonsoft.Json.JsonConvert.SerializeObject( new JSONRpcResult( post.id, string.Format( "function(){{{0}}}", s ), null ) ) );
#endif
                    WebApplication.Instance.ClientScriptRendered = true;
                }
                catch ( Exception e )
                {
                    context.Response.Write( JsonConvert.SerializeObject( new JSONRpcResult( post.id, string.Format( "function(){{{0}}}", e.Message ), null ) ) );
                }
            }
        }

        public bool IsReusable
        {
            get { return false; }
        }

        #endregion
    }
}