#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using NetJsWire.JsonRpcHandler.Attributes;

namespace NetJsWire.JsonRpcHandler.Util
{
    public static class Helper
    {
        public static IRenderer GetRenderer( object sender )
        {
            var attrs = GetLibraryType( sender.GetType() ).GetCustomAttributes( typeof (RendererAttribute), true );
            if ( attrs != null && attrs.Length > 0 )
            {
                return
                    ( IRenderer )
                    Activator.CreateInstance( ( ( RendererAttribute ) attrs[ 0 ] ).RendererType, new[] {sender} );
            }

            return null; // this should never happen
        }

        public static string GetClassName( object sender )
        {
            var attrs = GetLibraryType( sender.GetType() ).GetCustomAttributes( typeof (ClassNameAttribute), true );
            if ( attrs != null && attrs.Length > 0 )
            {
                return ( ( ClassNameAttribute ) attrs[ 0 ] ).ClassName;
            }
            return null;
        }

        private static Type GetLibraryType( Type type )
        {
            if ( type.FullName.Contains( "NetJsWire" ) )
            {
                return type;
            }
            else
            {
                return GetLibraryType( type.BaseType );
            }
        }
    }
}