#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections.Generic;
using System.Text;

namespace NetJsWire.JsonRpcHandler.Util
{
    public class JSON
    {
        public static Dictionary<string, string> JSONToDictionary( string source )
        {
            source = source.Trim( new[] {'{', '}'} );
            var pairs = source.Split( ',' );
            var ret = new Dictionary<string, string>();
            foreach ( var pair in pairs )
            {
                var tuple = pair.Split( ':' );
                ret[ tuple[ 0 ].Replace( "\"", "" ) ] = tuple[ 1 ].Replace( "\"", "" );
            }
            return ret;
        }

        public static Dictionary<string, string> GetPostObject( string source )
        {
            source = source.Trim( new[] {'{', '}'} );
            var ret = new Dictionary<string, string>();
            //"service":"EventsService","method":"Blur","id":10,"params":["Button_9|null"],"server_data":null
            var tmp = source.Split( ',' );
            foreach ( var pair in tmp )
            {
                var tuple = pair.Split( ':' );
                //ret[tuple[0].Replace("\"", "")] = tuple[1].Replace("\"", "").Replace('', ',');
            }
            return ret;
        }

        public static string CreateJSONResponse( params string[] source )
        {
            //string ret = AspnetRia.Util.JSON.CreateJSONObject("result:" + sb.ToString(), "error:null", "id:" + _id.ToString());
            var sb = new StringBuilder();
            sb.Append( "{result:" + source[ 0 ] + ",error:" + source[ 1 ] + ",id:" + source[ 2 ] + "}" );
            return sb.ToString();
        }

        public static string CreateJSONObject( params string[] source )
        {
            var sb = new StringBuilder();
            sb.Append( "{" );
            foreach ( var str in source )
            {
                var name = str.Split( ':' )[ 0 ];
                var val = str.Split( ':' )[ 1 ];
                sb.Append( "\"" + name + "\":" );
                if ( val != "null" )
                {
                    sb.Append( "\"" + val + "\"," );
                }
                else
                {
                    sb.Append( val + "," );
                }
            }
            sb.Remove( sb.Length - 1, 1 );
            sb.Append( "}" );
            return sb.ToString();
        }
    }
}