#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Web;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace NetJsWire.JsonRpcHandler.Util
{
    public class JSONRpcPost
    {
        private JSONRpcPostParams _jsonRpcPostParams;
        private object _params;

        public string id { get; set; }

        public string service { get; set; }

        public string method { get; set; }

        public object Params
        {
            get { return _params; }
            set
            {
                _params = value;
                if ( _params != null && ( ( JArray ) _params ).Count > 0 &&
                     ( ( JArray ) _params )[ 0 ] != null )
                {
                    _jsonRpcPostParams = ( JSONRpcPostParams ) JsonConvert.DeserializeObject( ( ( JContainer ) _params )[ 0 ].ToString(), typeof( JSONRpcPostParams ) );
                    //JsonConvert.Import( typeof (JSONRpcPostParams),
                    //                                            ( ( JArray ) _params )[ 0 ].ToString
                    //                                                () );
                }
                else
                {
                    _jsonRpcPostParams = new JSONRpcPostParams();
                }
            }
        }

        public object server_data { get; set; }

        public JSONRpcPostParams JSONRpcPostParams
        {
            get { return _jsonRpcPostParams; }
            set { _jsonRpcPostParams = value; }
        }

        public HttpFileCollection Files { get; set; }
    }
}