#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.Configuration;

namespace NetJsWire.JsonRpcHandler.Util
{
    public class SettingsHandler : ConfigurationSection
    {
        [ ConfigurationProperty( "MainClassName", DefaultValue = "Principal", IsRequired = true ) ]
        [ StringValidator( InvalidCharacters = "~!@#$%^&*()[]{}/;'\"|\\", MinLength = 1, MaxLength = 60 ) ]
        public String MainClassName
        {
            get { return ( String ) this[ "MainClassName" ]; }
            set { this[ "MainClassName" ] = value; }
        }

        [ ConfigurationProperty( "Library", DefaultValue = "Ext", IsRequired = false ) ]
        [ StringValidator( InvalidCharacters = "~!@#$%^&*()[]{}/;'\"|\\", MinLength = 1, MaxLength = 60 ) ]
        public String Library
        {
            get { return ( String ) this[ "Library" ]; }
            set { this[ "Library" ] = value; }
        }

        [ ConfigurationProperty( "ImagePath", DefaultValue = "images", IsRequired = false ) ]
        [ StringValidator( InvalidCharacters = "~!@#$%^&*()[]{};'\"|\\", MinLength = 1, MaxLength = 100 ) ]
        public String ImagePath
        {
            get { return ( String ) this[ "ImagePath" ]; }
            set { this[ "ImagePath" ] = value; }
        }
    }
}