#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.Diagnostics;
using System.Reflection;

namespace NetJsWire.JsonRpcHandler.Util
{
    public class TypeLoader
    {
        private static Assembly standardAssembly;

        public static Type GetType( string type )
        {
            Type t;
            if ( ( t = Type.GetType( type ) ) != null )
            {
                return t;
            }
            else if ( standardAssembly != null && ( t = standardAssembly.GetType( type, false, true ) ) != null )
            {
                return t;
            }
            else
            {
                foreach ( var a in AppDomain.CurrentDomain.GetAssemblies() )
                {
                    Debug.WriteLine( "looking in assembly {0}", a.FullName );
                    if ( ( t = a.GetType( type, false, true ) ) != null )
                    {
                        standardAssembly = a;
                        return t;
                    }
                    else if ( ( t = a.GetType( type + "`1", false, true ) ) != null )
                    {
                        standardAssembly = a;
                        return t;
                    }
                }
            }
            return null;
        }
    }
}