﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Globalization;
using System.IO;
using NetJsWire.JsonRpcHandler;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace NetJsWire.Util
{
    public static class Ext
    {
        public static string Get( this IWidget widget )
        {
            return string.Format( "Ext.get('{0}')", widget.Renderer.InternalID );
        }

        public static string GetCmp( this IWidget widget )
        {
            return string.Format( "Ext.getCmp('{0}')", widget.Renderer.InternalID );
        }

        public static string ToString( this JObject self, bool quote )
        {
            using ( var sw = new StringWriter( CultureInfo.InvariantCulture ) )
            {
                var jw = new JsonTextWriter( sw )
                        {
                            QuoteName = quote,
                            QuoteChar = '\'',
                            Formatting = Formatting.None
                        };
                self.WriteTo( jw );
                return sw.ToString();
            }
        }
    }
}