﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections.Generic;
using System.ComponentModel;
using NetJsWire.JsonRpcHandler;
using NetJsWire.Widgets.Data;
using Newtonsoft.Json;

namespace NetJsWire.Widgets.Config
{
    public class FormPanelConfigOptions : PanelConfigOptions
    {
        private List<BaseParam> _baseParams = new List<BaseParam>();

        public FormPanelConfigOptions( IWidget ownerWidget )
            : base( ownerWidget )
        {
        }

        [Description( "An object containing properties which are to be sent as parameters for every HTTP request." )]
        [DefaultValue( typeof( List<BaseParam> ) )]
        [Browsable( true )]
        [TypeConverter( typeof( CollectionConverter ) )]
        [DesignerSerializationVisibility( DesignerSerializationVisibility.Content )]
        [JsonProperty( DefaultValueHandling = DefaultValueHandling.Ignore, NullValueHandling = NullValueHandling.Ignore, ObjectCreationHandling = ObjectCreationHandling.Reuse )]
        public override List<BaseParam> BaseParams
        {
            get { return _baseParams; }
            set
            {
                SetValue( "baseParams", value, null, _baseParams );
                _baseParams = value;
            }
        }
    }
}
