﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.Widgets.Config;
using Newtonsoft.Json;

namespace NetJsWire.Widgets.Data
{
    [JsonObject( "Ext.data.Directproxy", MemberSerialization = MemberSerialization.OptIn, Id = "Ext.data.DirectProxy" )]
    [TypeConverter( typeof( ExpandableObjectConverter ) )]
    public class DirectProxy : DataProxy
    {
        [JsonProperty( "directFn" ), JsonConverter( typeof( NotQuotedJsonStringConverter ) )]
        [DefaultValue( ( string ) null )]
        public string DirectFn { get; set; }

        [JsonProperty( "paramOrder", NullValueHandling = NullValueHandling.Ignore ), JsonConverter( typeof( NotQuotedJsonStringConverter ) )]
        [DefaultValue( ( string ) null )]
        public string ParamOrder { get; set; }

        [JsonProperty( "paramsAsHash", DefaultValueHandling = DefaultValueHandling.Ignore )]
        [DefaultValue( false )]
        public bool ParamsAsHash { get; set; }
    }
}
