﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.ComponentModel;
using Newtonsoft.Json;

namespace NetJsWire.Widgets.Data
{
    [Serializable]
    [JsonObject]
    public class Field
    {
        [DefaultValue( ( string ) null )]
        public string Name { get; set; }

        [DefaultValue( false )]
        public bool AllowBlank { get; set; }

        [DefaultValue( ( string ) null )]
        public string Convert { get; set; }

        [DefaultValue( ( string ) null )]
        public string DateFormat { get; set; }

        [DefaultValue( ( string ) null )]
        public string DefaultValue { get; set; }

        [DefaultValue( ( string ) null )]
        public string Mapping { get; set; }

        [DefaultValue( ( SortDir ) 0 )]
        public SortDir SortDir { get; set; }

        [DefaultValue( ( string ) null )]
        public string SortType { get; set; }

        [DefaultValue( ( string ) null )]
        public string Type { get; set; }
    }
}
