﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System;
using System.ComponentModel;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace NetJsWire.Widgets.Data
{
    [Serializable]
    [JsonObject( MemberSerialization = MemberSerialization.OptOut )]
    public class SortInfo
    {
        [DefaultValue( null )]
        [JsonProperty( "field" )]
        public string SortProperty { get; set; }

        [DefaultValue( ( SortDir ) 0 )]
        [JsonProperty( "direction", DefaultValueHandling = DefaultValueHandling.Include )]
        [JsonConverter( typeof( StringEnumConverter ) )]
        public SortDir Direction { get; set; }

        public override string ToString()
        {
            if ( !string.IsNullOrWhiteSpace( SortProperty ) )
                return JsonConvert.SerializeObject( this );

            return null;
        }
    }
}
