﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Windows.Forms;
using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Core;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.Form
{
    [ClassName( "Ext.ux.form.FileUploadField" )]
    internal class FileUploadField : Widget, IRenderer
    {
        public FileUploadField( object baseObject )
            : base( baseObject )
        {
        }

        #region IRenderer Members

        public override void Render()
        {
            if ( !Rendered )
            {
                if ( BaseParent is IWidgetContainer )
                {
                    SetAttribute( ControlNode, "isInContainer", true );

                    if ( !string.IsNullOrEmpty( ( Base as Ui.Form.FileUploadField ).FieldLabel ) )
                        SetConstructionProperty( "fieldLabel", ( Base as Ui.Form.FileUploadField ).FieldLabel );
                }
                else
                {
                    SetConstructionProperty( "renderTo", ClientParentToRender );
                }

                EnsureParentNodePosition();

                SetConstructionProperty( "buttonText", ( ( Ui.Form.FileUploadField ) Base ).ButtonText );
                SetConstructionProperty( "width", ( ( Control ) Base ).Width );
            }

            base.Render();
        }

        #endregion
    }
}