﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Windows.Forms;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Core;
using NetJsWire.Widgets.Renderers.Core;
using NetJsWire.Widgets.Ui.Layout;

namespace NetJsWire.Widgets.Renderers.Form
{
    [ ClassName( "Ext.form.HtmlEditor" ) ]
    internal class HtmlEditor : Widget
    {
        public HtmlEditor( object baseObject )
            : base( baseObject )
        {
        }

        public override void Render()
        {
            if ( !Rendered )
            {
                if ( BaseParent is IWidgetContainer )
                {
                    SetAttribute( ControlNode, "isInContainer", true );
                    SetConstructionProperty( "isInContainer", true );

                    if ( BaseParent is Ui.Form.FormPanel || BaseParent is Ui.Form.FieldSet )
                    {
                        if ( ( BaseParent as IWidgetContainer ).Layout == LayoutType.Form )
                            SetConstructionProperty( "fieldLabel", ( ( Ui.Form.HtmlEditor ) Base ).FieldLabel );

                        ( ( Ui.Form.TextField ) Base ).SendServerUpdates = false;
                        SetConstructionProperty( "sendUpdates", false );
                    }
                }
                else
                {
                    SetStyleProperty( "position", "absolute" );
                    SetConstructionProperty( "renderTo", ClientParentToRender );
                }

                SetConstructionProperty( "width", ( ( Control ) Base ).Width );
                SetConstructionProperty( "height", ( ( Control ) Base ).ClientSize.Height );


                EnsureParentNodePosition();
            }
            base.Render();
        }
    }
}