﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.JsonRpcHandler.Attributes;

namespace NetJsWire.Widgets.Renderers.Form
{
    [ClassName( "Ext.ux.NNumberField" )]
    internal class NumberField : TextField
    {
        //protected new string _INPUT = "{0}.on(\"change\", function(tf, newValue, oldValue) {{SendToServer(\"{0}\", \"input\", \"{1}\", [tf.getValue(), tf.isValid()] );}});";
        protected new string _INPUT = string.Empty;

        public NumberField( object baseObject )
            : base( baseObject )
        {
        }

        public override void Render()
        {
            if ( !Rendered )
            {
                if ( !Base.AllowNegative )
                    SetConstructionProperty( "allowNegative", false );
                if ( !string.IsNullOrEmpty( Base.InvalidText ) )
                    SetConstructionProperty( "invalidText", Base.InvalidText );
                if ( !Base.AllowDecimals )
                    SetConstructionProperty( "allowDecimals", false );
                if ( Base.DecimalPrecision != 2 )
                    SetConstructionProperty( "decimalPrecision", Base.DecimalPrecision );
                if ( Base.DecimalSeparator != '.' )
                    SetConstructionProperty( "decimalSeparator", Base.DecimalSeparator );
            }
            base.Render();
        }
    }
}