﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.Layout
{
    [ ClassName( "Ext.Panel" ) ]
    internal class BorderLayout : Widget, IRenderer
    {
        private Ui.Layout.BorderLayout _bl;

        public BorderLayout( object baseObject )
            : base( baseObject )
        {
            _bl = ( Ui.Layout.BorderLayout ) baseObject;
        }

        #region IRenderer Members

        public override void Render()
        {
            if ( !Rendered )
            {
                SetAttribute( "isContainer", true );
                SetAttribute( "isInContainer", true );
                SetConstructionProperty( "isInContainer", true );

                EnsureParentNodePosition();
                //if (BaseParent is Ui.Layout.Panel)
                //{
                //    SetAttribute(ControlNode, "isInLayout", "true");
                //    SetConstructionProperty("region", ((Ui.Layout.Panel)BaseParent).Region);
                //    SetStyleProperty("height", ((Control)Base).Height);
                //    SetConstructionProperty("width", ((Control)Base).Width);
                //}
                //else if (BaseParent is Ui.Layout.BorderLayout)
                //{
                //    SetAttribute(ControlNode, "isInLayout", "true");
                //    SetConstructionProperty("region", ((Ui.Layout.BorderLayout)BaseParent).Region);
                //    SetStyleProperty("height", ((Control)Base).Height);
                //    SetConstructionProperty("width", ((Control)Base).Width);
                //}
                //else
                //{
                //    SetConstructionProperty("renderTo", ClientParentToRender);
                //    if (!((Ui.Layout.BorderLayout)Base).ClientWidth.IsEmpty)
                //        SetConstructionProperty("width", "'" + ((Ui.Layout.BorderLayout)Base).ClientWidth + "'");
                //    else
                //        SetConstructionProperty("width", ((Control)Base).Width + 15);

                //    if (!((Ui.Layout.BorderLayout)Base).ClientHeight.IsEmpty)
                //    {
                //        SetStyleProperty("height", "'" + ((Ui.Layout.BorderLayout)Base).ClientHeight + "'");
                //        //SetConstructionProperty("height", "'" + ((Ui.Layout.BorderLayout)Base).ClientHeight + "'");
                //    }
                //    else
                //    {
                //        //SetConstructionProperty("height", ((Control)Base).Height + 15);
                //        SetStyleProperty("height", ((Control)Base).ClientSize.Height + 15);
                //    }
                //}
                //AddStyleProperty("position", "absolute");
                //AddStyleProperty("top", ((Control)Base).Top);
                //AddStyleProperty("left", ((Control)Base).Left);

                if ( !string.IsNullOrEmpty( ( ( Ui.Layout.BorderLayout ) Base ).Region ) )
                    SetConstructionProperty( "region", ( ( Ui.Layout.BorderLayout ) Base ).Region );

                SetAttribute( ControlNode, "isLayout", "true" );
                SetConstructionProperty( "border", false );
                SetConstructionProperty( "layout", "border" );
                //SetConstructionProperty("minHeight", ((Control)Base).Height);
                SetConstructionProperty( "title", ( ( Ui.Layout.BorderLayout ) Base ).Title );
                //SetConstructionProperty("monitorResize", true);
                //SetConstructionProperty("items", "{region:'center', title:'Center', height:'300px', width:'300px' }");
                //ControlNode.AppendChild(WebApplication.Instance.XmlDocument.CreateNode("element", "items", ""));

                //BuildContentPanelDefinition(_bl.NorthPanel);
                //BuildContentPanelDefinition(_bl.SouthPanel);
                //BuildContentPanelDefinition(_bl.EastPanel);
                //BuildContentPanelDefinition(_bl.WestPanel);
                //BuildContentPanelDefinition(_bl.CenterPanel);
                //sb.Append("center: {closeOnTab:true}");

                //sb.Append("});");

                //WebApplication.Instance.Changes.Enqueue(sb.ToString());
                //Rendered = true;
            }
            base.Render();
        }

        #endregion

        private void BuildContentPanelDefinition( Ui.Layout.Panel cp )
        {
            if ( cp != null )
            {
                var nodeItem =
                    ControlNode[ "items" ].AppendChild( WebApplication.Instance.XmlDocument.CreateNode( "element",
                                                                                                        "item", "" ) );
                SetAttribute( nodeItem, "layout", "fit" );
                SetAttribute( nodeItem, "region", cp.Region );
                SetAttribute( nodeItem, "title", cp.Title );
                SetAttribute( nodeItem, "width", cp.Width );
                SetAttribute( nodeItem, "height", cp.Height );
                SetAttribute( nodeItem, "collapsible", cp.Collapsible );
                SetAttribute( nodeItem, "closable", cp.Closable );
                SetAttribute( nodeItem, "titleCollapse", true );
                SetAttribute( nodeItem, "name", cp.Renderer.ClientID );
                SetAttribute( nodeItem, "type", cp.UseIframe ? "NetJsWire.Panel" : "Ext.Panel" );
                SetAttribute( nodeItem, "useIframe", cp.UseIframe );
                SetAttribute( nodeItem, "url", cp.IframeUrl );
                SetAttribute( nodeItem, "split", cp.Split );
                SetAttribute( nodeItem, "floating", cp.Floating );
                cp.Renderer.Rendered = true;
            }
        }
    }
}