﻿//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Author: Jeronimo Milea
//
// Copyright 2007-2011 - Jeronimo Milea

using System;
using System.Collections.Generic;
using System.Text;
using NetJsWire.JSONRpcHandler;
using NetJsWire.Widgets.Renderers.Core;
using System.Windows.Forms;
using System.Drawing;

//TODO: Agregar SendToServer al prototype. Agregar "execute" como funcion por defecto en server y un evento en los controles capaces de recibirlo.

namespace NetJsWire.Widgets.Renderers.Layout
{
    [JSONRpcHandler.Attributes.ClassName("Ext.Panel")]
    internal class Panel : Widget, IRenderer
    {
        protected string _CLOSED = "{0}.on(\"close\", function() {{ SendToServer(\"{0}\", \"Closed\", \"{1}\", null); }}, {0});";
        public Panel(object baseObject)
            : base(baseObject)
        {
        }

        public override void Render()
        {
            if (!Rendered)
            {
                EnsureParentNodePosition();

				//if (!string.IsNullOrEmpty((Base as Ui.Layout.Panel).Region))
				//	SetAttribute(ControlNode, "region", !string.IsNullOrEmpty((Base as Ui.Layout.Panel).Region) ? (Base as Ui.Layout.Panel).Region.ToLower() : "center");
                if ((Base as Ui.Layout.Panel).UseIframe)
                {
                    SetAttribute(ControlNode, "useIframe", (Base as Ui.Layout.Panel).UseIframe);
                    SetAttribute(ControlNode, "url", (Base as Ui.Layout.Panel).IframeUrl);
                }
				if (!string.IsNullOrEmpty((Base as Ui.Layout.Panel).Region))
					SetConstructionProperty("region", (Base as Ui.Layout.Panel).Region.ToLower());

                if (BaseParent != null && BaseParent is Ui.Layout.BorderLayout)
                {
                    SetAttribute(ControlNode, "isInLayout", true);
                    SetAttribute(ControlNode, "parent", ClientParentToRender);
                    SetConstructionProperty("width", ((Control)Base).Width);
                    SetConstructionProperty("height", ((Control)Base).Height);
                    AddStyleProperty("height", ((Control)Base).Height);
                    SetConstructionProperty("collapsible", (Base as Ui.Layout.Panel).Collapsible);
                }
                else if (BaseParent != null && BaseParent is Ui.Layout.Panel)
                {
                    SetConstructionProperty("renderTo", ClientParentToRender);
                    SetAttribute(ControlNode, "isInLayout", false);
                    AddStyleProperty("position", "absolute");
                    AddStyleProperty("top", ((Control)Base).Top);
                    AddStyleProperty("left", ((Control)Base).Left);
                    AddStyleProperty("height", ((Control)Base).Height);
                    SetConstructionProperty("width", ((Control)Base).Width);
                    SetConstructionProperty("height", ((Control)Base).Height);
                    SetConstructionProperty("collapsible", (Base as Ui.Layout.Panel).Collapsible);
                }
                else
                {

                    AnchorStyles _as = ((Control)Base).Anchor;

                    SetConstructionProperty("renderTo", ClientParentToRender);
                    SetAttribute(ControlNode, "isInLayout", false);

                    SetStyleProperty("position", "absolute");

                    if ((_as & AnchorStyles.Bottom) == AnchorStyles.Bottom)
                        SetStyleProperty("bottom", ((Control)Base).Parent.ClientSize.Height - (((Control)Base).Top + ((Control)Base).Height));
                    if ((_as & AnchorStyles.Top) == AnchorStyles.Top)
                        SetStyleProperty("top", ((Control)Base).Top);
                    if ((_as & AnchorStyles.Left) == AnchorStyles.Left)
                        SetStyleProperty("left", ((Control)Base).Left);
                    if ((_as & AnchorStyles.Right) == AnchorStyles.Right)
                        SetStyleProperty("right", ((Control)Base).Parent.ClientSize.Width - (((Control)Base).Left + ((Control)Base).Width));

                    //SetConstructionProperty("y", ((Control)Base).Top);
                    //SetConstructionProperty("x", ((Control)Base).Left);

                    //SetStyleProperty("height", ((Control)Base).ClientSize.Height);

                    //if (BaseParent != null && BaseParent is Ui.Window.Window)
                    //    SetStyleProperty("width", ((Control)Base).ClientSize.Width - 8);
                    //else
                    //    SetStyleProperty("width", ((Control)Base).ClientSize.Width);

                    if (!((_as & AnchorStyles.Top) == AnchorStyles.Top) || !((_as & AnchorStyles.Bottom) == AnchorStyles.Bottom))
                        SetStyleProperty("height", ((Control)Base).ClientSize.Height);

                    if (!((_as & AnchorStyles.Left) == AnchorStyles.Left) || !((_as & AnchorStyles.Right) == AnchorStyles.Right))
                        SetStyleProperty("width", ((Control)Base).ClientSize.Width);
                    //SetConstructionProperty("height", ((Control)Base).Height);

                    //SetConstructionProperty("width", ((Control)Base).Width);
                    //SetConstructionProperty("height", ((Control)Base).Height);
                    //SetAttribute(ControlNode, "height", ((Control)Base).Height);
                    
                    SetConstructionProperty("collapsible", (Base as Ui.Layout.Panel).Collapsible);
                }

				SetConstructionProperty("layout", (Base as Ui.Layout.Panel).Layout.ToString().ToLower());

            }
            base.Render();
            //SetAttribute(ControlNode["options"], "anchor", "'none none'");
            int t = 0;
        }
    }
}
