#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Text;
using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;

namespace NetJsWire.Widgets.Renderers.MessageBox
{
    [ ClassName( "NetJsWire.MessageBox" ) ]
    internal class MessageBox : Window.Window
    {
        protected string _ACCEPT = string.Empty;
        protected string _CANCEL = string.Empty;

        public MessageBox( object baseObject )
            : base( baseObject )
        {
        }

        public override void Render()
        {
            if ( !Rendered )
            {
                var sb = new StringBuilder();
                var mb = ( Ui.MessageBox.MessageBox ) Base;
                sb.AppendFormat( "{0}(\"{1}\",\"{2}\", \"{3}\", {4});", ClassName, InternalID, mb.Text, mb.Message,
                                 mb.IsConfirm.ToString().ToLower() );
                WebApplication.Instance.AddSingleChange( sb.ToString() );
                //WebApplication.Instance.Changes.Enqueue(sb.ToString());
                Rendered = true;
            }
            //base.Render();
        }
    }
}