﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.Tabs
{
    [ ClassName( "Ext.TabPanel.Page" ) ]
    internal class TabPage : Widget
    {
        public TabPage( object baseObject )
            : base( baseObject )
        {
        }

        public override void Render()
        {
            if ( !Rendered )
            {
                SetAttribute( "isInContainer", true );
                SetAttribute( "isContainer", true );
                SetAttribute( "idx",
                              ( ( Base as Ui.Tabs.TabPage ).Parent as Ui.Tabs.TabControl ).TabPages.IndexOf(
                                  Base as Ui.Tabs.TabPage ) );
                SetConstructionProperty( "isInContainer", true );
                SetConstructionProperty( "title", ( Base as Ui.Tabs.TabPage ).Text );

                if ( !string.IsNullOrEmpty( ( Base as Ui.Tabs.TabPage ).ToolTipText ) )
                    SetConstructionProperty( "tabTip", ( Base as Ui.Tabs.TabPage ).ToolTipText );

                RemoveConstructionProperty( "xtype" );
                EnsureParentNodePosition();
            }

            base.Render();
        }
    }
}