﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.ToolBar
{
    [ ClassName( "Ext.menu.ColorMenu" ) ]
    internal class ColorMenu : Widget, IRenderer
    {
        private readonly Ui.ToolBar.ColorMenu _mi;
        protected string _COLORSELECTED = "function(i, c) {{ SendToServer(\"{0}\", \"ColorSelected\", \"{1}\", c); }}";
        protected string _COLORSELECTED_CLIENT_NAME = "select";

        public ColorMenu( object baseObject )
            : base( baseObject )
        {
            //_CLICK = "";
            _mi = ( Ui.ToolBar.ColorMenu ) baseObject;
        }

        #region IRenderer Members

        public override void Render()
        {
            if ( !Rendered )
            {
                EnsureParentNodePosition();
                SetAttribute( "isInContainer", true );

                //SetAttribute( ControlNode, "menu", ClientParentToRender );
                SetAttribute( ControlNode, "hasItems", false );

                SetConstructionProperty( "text", _mi.Text );

                if ( !string.IsNullOrEmpty( _mi.ToolTipText ) )
                    SetConstructionProperty( "tooltip", _mi.ToolTipText );

                if ( _mi.Image != null )
                {
                    SetConstructionProperty( "cls", "x-btn-text-icon" );
                    SetConstructionProperty( "icon", "webapp/Images.ashx?_id=" + InternalID );
                }

                //if ( _mi.HasClick )
                //{
                //    //SetConstructionProperty("handler", string.Format("function() {{ SendToServer('{0}', 'Click', '{0}', null); }}", InternalID));
                //    SetConstructionProperty( "handler", "NetJsWire.ClickHandler" );
                //    _events.Add( "Click" );
                //    //_mi.Click += new EventHandler(_mi_Click);
                //}
            }

            base.Render();
        }

        #endregion
    }
}