#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.ToolBar
{
    [ ClassName( "Ext.Toolbar.Button" ) ]
    internal class DropDownButton : Widget, IRenderer
    {
        private readonly Ui.ToolBar.DropDownButton _db;

        public DropDownButton( object baseObject )
            : base( baseObject )
        {
            _db = ( Ui.ToolBar.DropDownButton ) baseObject;
        }

        #region IRenderer Members

        public override void Render()
        {
            if ( !Rendered )
            {
                EnsureParentNodePosition();
                //if (!((Ui.ToolBar.ToolBar)_db.Owner).Renderer.Rendered)
                //    ((Ui.ToolBar.ToolBar)_db.Owner).Renderer.Render();

                //SetAttribute(ControlNode, "parent", ClientParentToRender);

                SetAttribute( ControlNode, "hasItems", _db.HasDropDownItems );

                SetAttribute( "isInContainer", true );

                if ( _db.HasDropDownItems )
                {
                    SetAttribute( "isContainer", true );
                }

                SetConstructionProperty( "text", _db.Text );
                SetConstructionProperty( "tooltip", _db.ToolTipText );

                SetAttribute( ControlNode, "idx", _db.Owner.Items.IndexOf( _db ) );

                if ( _db.Image != null )
                {
                    if ( string.IsNullOrEmpty( _db.Text ) )
                        SetConstructionProperty( "cls", "x-btn-icon" );
                    else
                        SetConstructionProperty( "cls", "x-btn-text-icon" );

                    if ( string.IsNullOrEmpty( _db.IconCls ) )
                        SetConstructionProperty( "icon", "webapp/Images.ashx?_id=" + InternalID );
                }

                if ( !string.IsNullOrEmpty( _db.IconCls ) )
                    SetConstructionProperty( "iconCls", _db.IconCls );
            }

            base.Render();
        }

        #endregion
    }
}