﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Windows.Forms;
using NetJsWire.JsonRpcHandler;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Renderers.Core;

namespace NetJsWire.Widgets.Renderers.ToolBar
{
    [ ClassName( "NetJsWire.TextField" ) ]
    internal class TextField : Widget, IRenderer
    {
        private readonly ToolStripTextBox _tf;

        public TextField( object baseObject )
            : base( baseObject )
        {
            _tf = baseObject as ToolStripTextBox;
        }

        #region IRenderer Members

        public override void Render()
        {
            if ( !Rendered )
            {
                if ( !( ( Ui.ToolBar.ToolBar ) _tf.Owner ).Renderer.Rendered )
                    ( ( Ui.ToolBar.ToolBar ) _tf.Owner ).Renderer.Render();

                ConstructorParameters = "\"" + ClientID + "\"";

                SetStyleProperty( "width", _tf.Width );
                //SetConstructionProperty("renderTo", ClientParentToRender);
                SetConstructionProperty( "value", _tf.Text );
                SetConstructionProperty( "width", _tf.Width );
                SetConstructionProperty( "disabledClass", "disabled-tf" );
            }
            base.Render();
        }

        #endregion
    }
}