﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections.Generic;

namespace NetJsWire.Widgets.Ui.Form
{
    public class ComboBoxColumnCollection : List<ComboBoxColumn>
    {
        private readonly ComboBox parent;

        public ComboBoxColumnCollection( ComboBox combo )
        {
            parent = combo;
        }

        public ComboBoxColumn this[ string name ]
        {
            get
            {
                foreach ( var col in this )
                {
                    if ( col.Name == name )
                    {
                        return col;
                    }
                }
                return null;
            }
        }

        public new void Add( ComboBoxColumn column )
        {
            column.Parent = parent;
            base.Add( column );
            parent._headersChanged = true;
        }

        /*
         public ComboBoxColumn Add(string field)
         {
             ComboBoxColumn col = new ComboBoxColumn(field);
             Add(col);
             return col;
         }
         */
    }
}