#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.JsonRpcHandler.Attributes;
using NetJsWire.Widgets.Config;

namespace NetJsWire.Widgets.Ui.Form
{
    [ Renderer( typeof (Renderers.Form.HtmlEditor) ) ]
    public partial class HtmlEditor : TextField
    {
        private IConfigOptions _configOptions;

        public HtmlEditor()
        {
            InitializeComponent();
        }

        public HtmlEditor( IContainer container )
        {
            container.Add( this );

            InitializeComponent();
        }

        [ RefreshProperties( RefreshProperties.All ),
          DesignerSerializationVisibility( DesignerSerializationVisibility.Content ), Category( "Config" ) ]
        public override IConfigOptions ConfigOptions
        {
            get
            {
                if ( _configOptions == null )
                {
                    _configOptions = new FieldConfigOptions( this ) { Xtype = "htmleditor" };
                }
                return _configOptions;
            }
        }
    }
}