#region Header
// Copyright 2007-2011, Jernimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.ComponentModel;
using NetJsWire.JsonRpcHandler.Attributes;

namespace NetJsWire.Widgets.Ui.Form
{
    [Renderer( typeof( Renderers.Form.NumberField ) )]
    public class NumberField : TextField
    {
        private bool _allowDecimals = true;
        private bool _allowNegative = true;
        private int _decimalPrecision = 2;
        private char _decimalSeparator = '.';
        private string _invalidText = string.Empty;

        [DefaultValue( true )]
        public bool AllowNegative
        {
            get { return _allowNegative; }
            set { _allowNegative = value; }
        }

        [DefaultValue( ( string ) null )]
        public string InvalidText
        {
            get { return _invalidText; }
            set { _invalidText = value; }
        }

        [DefaultValue( true )]
        public bool AllowDecimals
        {
            get { return _allowDecimals; }
            set { _allowDecimals = value; }
        }

        [DefaultValue( 2 )]
        public int DecimalPrecision
        {
            get { return _decimalPrecision; }
            set { _decimalPrecision = value; }
        }

        [DefaultValue( '.' )]
        public char DecimalSeparator
        {
            get { return _decimalSeparator; }
            set { _decimalSeparator = value; }
        }
    }
}