﻿//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Author: Jeronimo Milea
//
// Copyright 2007-2011 - Jeronimo Milea

using NetJsWire.JsonRpcHandler;

namespace NetJsWire.Widgets.Ui.Layout
{
    partial class BorderLayout
    {
        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        Panel northPanel;

        public Panel NorthPanel
        {
            get { return northPanel; }
            set { northPanel = value;
                if (value != null)
                {
                    northPanel.Dock = System.Windows.Forms.DockStyle.Top;
                    northPanel.Region = "north";
                }
            }
        }
        Panel westPanel;

        public Panel WestPanel
        {
            get { return westPanel; }
            set
            {
                westPanel = value;
                if (value != null)
                {
                    westPanel.Dock = System.Windows.Forms.DockStyle.Left;
                    westPanel.Region = "west";
                }
            }
        }
        Panel centerPanel;

        public Panel CenterPanel
        {
            get { return centerPanel; }
            set { centerPanel = value;
                if (value != null)
                {
                    centerPanel.Dock = System.Windows.Forms.DockStyle.Fill;
                    centerPanel.Region = "center";
                }
            }
        }
        Panel eastPanel;

        public Panel EastPanel
        {
            get { return eastPanel; }
            set
            {
                eastPanel = value;
                if (value != null)
                {
                    eastPanel.Dock = System.Windows.Forms.DockStyle.Right;
                    eastPanel.Region = "east";
                }
            }
        }
        Panel southPanel;

        public Panel SouthPanel
        {
            get { return southPanel; }
            set
            {
                southPanel = value;
                if (value != null)
                {
                    southPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
                    southPanel.Region = "south";
                }
            }
        }

        /// <summary> 
        /// Clean up any resources being used.
        /// </summary>
        /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
            
            WebApplication.Instance.RemoveObject(((Renderers.Layout.BorderLayout)Renderer).InternalID);
            base.Dispose(disposing);
        }

        #region Component Designer generated code

        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            //this.northPanel = new System.Windows.Forms.Panel();
            //this.westPanel = new System.Windows.Forms.Panel();
            //this.centerPanel = new System.Windows.Forms.Panel();
            //this.eastPanel = new System.Windows.Forms.Panel();
            //this.southPanel = new System.Windows.Forms.Panel();
            this.SuspendLayout();
            //// 
            //// northPanel
            //// 
            //this.northPanel.BackColor = System.Drawing.Color.Blue;
            //this.northPanel.Dock = System.Windows.Forms.DockStyle.Top;
            //this.northPanel.Location = new System.Drawing.Point(0, 0);
            //this.northPanel.Name = "northPanel";
            //this.northPanel.Size = new System.Drawing.Size(400, 50);
            //this.northPanel.TabIndex = 0;
            //// 
            //// westPanel
            //// 
            //this.westPanel.BackColor = System.Drawing.Color.BlueViolet;
            //this.westPanel.Dock = System.Windows.Forms.DockStyle.Left;
            //this.westPanel.Location = new System.Drawing.Point(0, 50);
            //this.westPanel.Name = "westPanel";
            //this.westPanel.Size = new System.Drawing.Size(50, 100);
            //this.westPanel.TabIndex = 1;
            //// 
            //// eastPanel
            //// 
            //this.eastPanel.BackColor = System.Drawing.Color.Brown;
            //this.eastPanel.Dock = System.Windows.Forms.DockStyle.Right;
            //this.eastPanel.Location = new System.Drawing.Point(350, 50);
            //this.eastPanel.Name = "eastPanel";
            //this.eastPanel.Size = new System.Drawing.Size(50, 100);
            //this.eastPanel.TabIndex = 2;
            //// 
            //// southPanel
            //// 
            //this.southPanel.BackColor = System.Drawing.Color.Chartreuse;
            //this.southPanel.Dock = System.Windows.Forms.DockStyle.Bottom;
            //this.southPanel.Location = new System.Drawing.Point(0, 150);
            //this.southPanel.Name = "southPanel";
            //this.southPanel.Size = new System.Drawing.Size(400, 50);
            //this.southPanel.TabIndex = 3;
            //// 
            //// centerPanel
            //// 
            //this.centerPanel.BackColor = System.Drawing.Color.Chocolate;
            //this.centerPanel.Dock = System.Windows.Forms.DockStyle.Fill;
            //this.centerPanel.Location = new System.Drawing.Point(50, 50);
            //this.centerPanel.Name = "centerPanel";
            //this.centerPanel.Size = new System.Drawing.Size(300, 100);
            //this.centerPanel.TabIndex = 4;
            // 
            // BorderLayout
            // 
            //this.Controls.Add(this.CenterPanel);
            //this.Controls.Add(this.EastPanel);
            //this.Controls.Add(this.WestPanel);
            //this.Controls.Add(this.NorthPanel);
            //this.Controls.Add(this.SouthPanel);
            this.Size = new System.Drawing.Size(400, 200);
            this.ResumeLayout(false);

        }

        #endregion

    }
}
