﻿#region Header
// Copyright 2007-2011, Jerónimo Milea
// 
// This file is part of NetJsWire.
// 
//     NetJsWire is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
// 
//     NetJsWire is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
// 
//     You should have received a copy of the GNU General Public License
//     along with NetJsWire.  If not, see <http://www.gnu.org/licenses/>.
#endregion

using System.Collections.ObjectModel;
using System.Windows.Forms;

namespace NetJsWire.Widgets.Ui.List
{
    public class ListViewColumnCollection : Collection<ListViewColumn>
    {
        private readonly ListView _owner;

        public ListViewColumnCollection( ListView owner )
        {
            _owner = owner;
        }

        public new void Add( ListViewColumn item )
        {
            _owner.Columns.Add( new DataGridViewColumn { DataPropertyName = item.DataIndex, HeaderText = item.Header, Name = item.DataIndex + "Column" } );
            base.Add( item );
        }

        public new void Remove( ListViewColumn item )
        {
            _owner.Columns.Remove( item.DataIndex + "Column" );
            base.Remove( item );
        }
    }
}
